# coding: utf-8
"""Waylay rules engine models.

This code was generated from the OpenAPI documentation of 'Waylay rules engine'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

import re

from pydantic import (
    ConfigDict,
    Field,
    StrictStr,
    field_validator,
)
from typing_extensions import (
    Annotated,  # >=3.11
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel

from ..models.plugin_update_spec_from_version import PluginUpdateSpecFromVersion


class PluginUpdateSpec(WaylayBaseModel):
    """PluginUpdateSpec."""

    name: StrictStr = Field(description="Name of the plugin to update")
    from_version: PluginUpdateSpecFromVersion = Field(alias="fromVersion")
    to_version: Annotated[str, Field(strict=True)] = Field(alias="toVersion")

    @field_validator("to_version")
    @classmethod
    def to_version_validate_regular_expression(cls, value):
        """Validate the regular expression."""
        if not re.match(r"\d+\.\d+\.\d+", value):
            raise ValueError(r"must validate the regular expression /\d+\.\d+\.\d+/")
        return value

    model_config = ConfigDict(
        populate_by_name=True, protected_namespaces=(), extra="ignore"
    )
