# coding: utf-8
"""Waylay rules engine models.

This code was generated from the OpenAPI documentation of 'Waylay rules engine'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

from typing import Any, Dict

from pydantic import (
    ConfigDict,
    Field,
    StrictBool,
    StrictInt,
    StrictStr,
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel

from ..models.reactive_task_setting_type import ReactiveTaskSettingType


class TaskSettings(WaylayBaseModel):
    """TaskSettings."""

    name: StrictStr | None = None
    resource: StrictStr | None = Field(
        default=None, description="Unique resource identifier"
    )
    reset_observations: StrictBool | None = Field(
        default=True, alias="resetObservations"
    )
    parallel: StrictBool | None = True
    gates_need_full_observation: StrictBool | None = Field(
        default=False, alias="gatesNeedFullObservation"
    )
    tags: Dict[str, Any] | None = Field(
        default=None,
        description="Key-value pairs on which you can set at task creation and later filter tasks",
    )
    variables: Dict[str, Any] | None = Field(
        default=None,
        description="set of variables which will be used when starting a task and will automatically be injected in the template before starting a task.",
    )
    type: ReactiveTaskSettingType
    time_zone: StrictStr | None = Field(
        default=None,
        description="Optional identifier of the time zone in which the schedule expression is to be interpreted",
        alias="timeZone",
    )
    frequency: StrictInt = Field(description="polling frequency in milliseconds")

    model_config = ConfigDict(
        populate_by_name=True, protected_namespaces=(), extra="allow"
    )
