# coding: utf-8
"""Waylay rules engine models.

This code was generated from the OpenAPI documentation of 'Waylay rules engine'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

from typing import Any, Dict

from pydantic import (
    ConfigDict,
    Field,
    StrictStr,
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel

from ..models.validation_issue_severity import ValidationIssueSeverity


class ValidationIssue(WaylayBaseModel):
    """ValidationIssue."""

    type: StrictStr = Field(
        description='Indication of "area" where validation issue is situated'
    )
    message: StrictStr = Field(description="Description of the issue")
    severity: ValidationIssueSeverity
    details: Dict[str, Any] | None = Field(
        default=None,
        description="Object containing identifying information on what gives the issue",
    )
    suggestion: StrictStr | None = Field(
        default=None,
        description="Suggestion on how to change the object to get the issue fixed",
    )

    model_config = ConfigDict(
        populate_by_name=True, protected_namespaces=(), extra="ignore"
    )
